Index: serial/flatsax.py
===================================================================
RCS file: /cvs/Quotient/nevow/serial/flatsax.py,v
retrieving revision 1.2
diff -u -r1.2 flatsax.py
--- serial/flatsax.py	21 Jan 2004 05:12:12 -0000	1.2
+++ serial/flatsax.py	3 Feb 2004 21:37:20 -0000
@@ -1,14 +1,11 @@
-
-
-from xml.sax import ContentHandler
-from xml.sax import make_parser
-#from xml.sax.handler import feature_namespaces
-
+from xml.sax import make_parser, handler
+import xml as pyxml
 
 from nevow.stan import xml, Tag, directive
 
+bad_version = pyxml.version_info[0] == 0 and pyxml.version_info[1] < 8
 
-class ToStan(ContentHandler):
+class ToStan(handler.ContentHandler, handler.EntityResolver):
     directiveMapping = {
         'render': 'renderer',
         'data': 'data',
@@ -17,9 +14,17 @@
     attributeList = [
         'pattern', 'slot', 'macro', 'fill-slot', 'key',
     ]
-
+    
+    def resolveEntity(self, publicId, systemId):
+        ## This doesn't seem to get called, which is good.
+        raise Exception("resolveEntity should not be called. We don't use external DTDs.")
+
+    def skippedEntity(self, name):
+        self.current.append(xml("&%s;"%name))
+        
     def startDocument(self):
-        self.document = [xml('<?xml version="1.0"?>\n')]
+        self.document = []
+#        self.document = [xml('<?xml version="1.0"?>\n')]
         self.current = self.document
         self.stack = []
 
@@ -51,7 +56,7 @@
         self.current = el.children
 
     def characters(self, ch):
-        self.current.append(xml(ch))
+        self.current.append(ch)
 
     def endElement(self, name):
         me = self.stack.pop()
@@ -62,12 +67,23 @@
 
 
 def parse(fl):
+    ## Earlier PyXMLs don't handle non-standard entities (e.g. &copy;) 
+    ## correctly. They will either give an error or simply ignore the
+    ## entity producing bad output.
+    
+    if bad_version:
+        raise Exception("Please use PyXML later than 0.8. Earlier ones are too buggy.")
+    
     parser = make_parser()
-#    parser.setFeature(feature_namespaces, 0)
+    parser.setFeature(handler.feature_validation, 0)
+    parser.setFeature(handler.feature_namespaces, 0)
+    parser.setFeature(handler.feature_external_ges, 0)
+    parser.setFeature(handler.feature_external_pes, 0)
+    
     s = ToStan()
     parser.setContentHandler(s)
-
-#    setEntityResolver()
+    parser.setEntityResolver(s)
+    
     parser.parse(fl)
 
     return s.document
